package com.szpg.task;

import com.szpg.db.dao.impl.PgAcuRdcmdDaoImpl;
import com.szpg.db.data.PgAcuRdcmd;
import com.szpg.plc.message.AppCommand;
import com.szpg.plc.message.command.read.ReadYWStatusCommand;
import com.szpg.plc.protocol.DTProtocolInterface;
import com.szpg.plc.protocol.ProtocolFactory;
import com.szpg.plc.server.ACUClient;
import com.szpg.plc.server.ACUClientUtil;
import com.szpg.plc.util.ByteUtil;

public class ReadYWStatusTask implements Runnable {

	private ACUClient client;
	private AppCommand appCommand;

	public ReadYWStatusTask(ACUClient client, AppCommand command) {
		this.client = client;
		this.appCommand = command;
	}

	@Override
	public void run() {
		DTProtocolInterface finspi = ProtocolFactory.getDefaultDTProtocol();
		byte[] content = finspi.messageToBytes(appCommand);
		
		// 发送读取爆管液位参数内存命令
		ACUClientUtil.getInstance().sendACUCommand(client, content);
		
		ReadYWStatusCommand ywAlmCmd = (ReadYWStatusCommand) appCommand;

		// 发送完成之后将命令保存在数据库中
		PgAcuRdcmd cmd = new PgAcuRdcmd();
		cmd.setCmd_type(ywAlmCmd.getCommandType());
		cmd.setDest(ywAlmCmd.getDestinationId());
		cmd.setMem_area_cd(ByteUtil.binToHexString(new byte[] { ywAlmCmd.getMemoryArea() }));
		cmd.setStart_mem_word(ywAlmCmd.getStartAddress().substring(0, 4));
		cmd.setStart_mem_bit(ywAlmCmd.getStartAddress().substring(4));
		cmd.setCount_word(ywAlmCmd.getCountWord());
		cmd.setCount_bit(ywAlmCmd.getCountBit());
		cmd.setCount_sensor(ywAlmCmd.getCountSensor());
		
		new PgAcuRdcmdDaoImpl().addCmdRecord(cmd);
	}

}
